/*
 * "Peko" Visual Novel System
 *
 * All Rights Reserved.
 * Copyright (c) 1999-2003 Tsukuba Bunko.
 *
 * $Id: StageElementHandler.java,v 1.1 2005/07/11 12:49:19 ppoi Exp $
 */
package tsukuba_bunko.peko.scenario.stage;

import	tsukuba_bunko.peko.scenario.ElementHandler;


/**
 * <samp>stage</samp> vf̍\vf <code>ElementHandler</code> ɋʂ̏񋟂܂B
 * @author	$Author: ppoi $
 * @version	$Revision: 1.1 $
 */
public abstract class StageElementHandler	extends ElementHandler	{

	/**
	 * <code>StageElementHandler</code> ̃CX^X쐬邽߂ɃTuNX̃RXgN^Ă΂܂B
	 */
	protected StageElementHandler()
	{
		super();
	}


	/**
	 * StageCoordinator 擾܂B
	 * @return	StageCoordinator
	 */
	public StageCoordinator getStageCoordinator()
	{
		return getSceneContext().getSceneProcessor().getStageCoordinator();
	}


//
//	ContentHandler ̎
//
	public void startDocument()
	{
		getStageCoordinator().begin();
	}

	public void endDocument()
	{
		getStageCoordinator().commit();
	}
}
