/*
 * Common Library for TBAS Softwares
 * Language: Java
 *
 * All Rights Reserved.
 * Copyright (c) 1999-2003 Tsukuba Bunko.
 *
 * $Id: ReflectionUtil.java,v 1.1 2005/07/11 12:49:19 ppoi Exp $
 */
package tsukuba_bunko.util;

import	java.lang.reflect.Method;


/**
 * tNVT|[g邽߂̃[eBeBNXłB
 * @author	$Author: ppoi $
 * @version	$Revision: 1.1 $
 */
public final class ReflectionUtil	{

	/**
	 * <code>ReflectionUtil</code> ̓CX^X𐶐ł܂B
	 */
	private ReflectionUtil(){;}


	/**
	 * \bh܂B
	 * @param	clazz	Ώۂ̃NX
	 * @param	methodName	郁\bh
	 * @param	parameterTypes	郁\bh̉NXXg(z)
	 * @param	searchSuperclasses	X[p[NXΏۂɂꍇ <code>true</code>AȊȌꍇ <code>false</code>
	 * @return	ʁB\bhoȂꍇ <code>null</code>
	 */
	public static Method findMethod( Class clazz, String methodName, Class[] parameterTypes, boolean searchSuperclasses )
	{
		Method	method = null;
		do	{
			try	{
				method = clazz.getDeclaredMethod( methodName, parameterTypes );
			}
			catch( NoSuchMethodException nsme )	{
				//ignore.
			}
			clazz = clazz.getSuperclass();
		} while( (method == null) && (clazz != null) && searchSuperclasses );

		return method;
	}
}